/*
    Copyright (C) 2012 Bartosz Broda, Jacek Bochenek, Łukasz Biłeńkij, 
    Damian Jaworski, Wojciech Mazur, Dominik Piasecki, Maciej Piasecki, 
    Radosław Ramocki
    
    This program is free software; you can redistribute it and/or modify it
under the terms of the GNU Lesser General Public License as published by the Free
Software Foundation; either version 3 of the License, or (at your option)
any later version.

    This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. 

    See the LICENSE and COPYING files for more details.
*/

#include "MatrixSaverSuperMatrix.h"


MatrixSaverSuperMatrix::MatrixSaverSuperMatrix(int numOfRows)
{
	this->numOfRows = numOfRows;
}
void MatrixSaverSuperMatrix::initialize()
{
	matrix = Matrices::CRSMatrixPtr(new Matrices::CRSMatrix("ResultsOfSimilarity",numOfRows,numOfRows));
}

MatrixSaverSuperMatrix::~MatrixSaverSuperMatrix()
{
	matrix.reset();
}

bool MatrixSaverSuperMatrix::isSimetrical(bool cmpSimetrical)
{

	Config* cfg = Config::getInstance();
	if(cmpSimetrical && cfg->kBestResults>=numOfRows && cfg->wordsFile=="")
	{
		isSimetric=true;
		return true;
	}
	else
	{
		isSimetric=false;
		return false;
	}
}

void MatrixSaverSuperMatrix::addValues(int rowNumber,int numOfValues,int *indexTable,double *valueTable)
{
	for(int i=0;i<numOfValues;i++)
	{

		matrix->SetCell(valueTable[i],rowNumber,indexTable[i]);

		if(isSimetric)
			matrix->SetCell(valueTable[i],indexTable[i],rowNumber);

	}

}

void MatrixSaverSuperMatrix::finalize()
{
	Matrices::IO::WriteToSingleFile(matrix,Config::getInstance()->resultsFile);
}
